/******** <lalVerbatim file="FCTFinalizeSearchCV"> ******** 
Author: Wen, L. 
$Id: FCTFinalizeSearch.c,v 1.5 2001/05/16 00:00:26 lwen Exp $ 
********* </lalVerbatim> ********/ 

#include <FCTGeneral.h>
#include <FCTFinalizeSearch.h> 


NRCSID( FCTFINALIZESEARCHC, "$Id: FCTFinalizeSearch.c,v 1.5 2001/05/16 00:00:26 lwen Exp $");

void 
LALFinalizeSearch( 
		  LALStatus *status, 
		  void **searchParams ) 
{

  FCTSearchParams   *params;

  INITSTATUS( status, "LALFinalizeSearch", FCTFINALIZESEARCHC ); 
  ATTATCHSTATUSPTR (status);

#ifdef FCT_SO_DEBUG  
  
  /*    lalDebugLevel=24;  */
  printf("in FinalizeSearch()\n");
#endif


  params=(FCTSearchParams *) *searchParams;


  /*  free searchParams   */

  if (! params->startIndices ||! params->endIndices  ||! params->segLengthPerRun || ! params->segLengthPerRun ||  ! params->numSlaves || ! params->numSegPerDim)
   {
     ABORT(status, FINALIZESEARCH_ENULL,FINALIZESEARCH_MSGENULL); 
   }
#ifdef FCT_SO_DEBUG

    printf("startIndices=%i,%i,%i,%i,%i\n",params->startIndices[1],params->endIndices[1],params->indicesLength[1],params->segLengthPerRun[1],params->numSegPerDim[1]);
#endif

  LALFree(params->startIndices);
  LALFree(params->endIndices );
  LALFree(params->indicesLength);
  LALFree(params->segLengthPerRun);
  LALFree(params->numSegPerDim);
  LALFree( params->numSlaves );
  /*  if slave  */
  if ( ! params->searchMaster )
  {
    if (! (&params->fctInParams->fctInput) || !params->fctInParams->cube || !(&params->fctInParams->fctPlan) || !params->fctInParams->fctPlan || !params->fctInParams->cube)
    {
     ABORT(status, FINALIZESEARCH_ENULL,FINALIZESEARCH_MSGENULL); 
    } 

    LALCDestroyVector(status->statusPtr, &(params->fctInParams->fctInput));
    CHECKSTATUSPTR (status);

    /*  specific to FCT  */
    LALDestroyFCTPlan(status->statusPtr, &(params->fctInParams->fctPlan));
    CHECKSTATUSPTR (status);


    LALFree(params->fctInParams->cube);
    LALFree(params->fctInParams);
  }/*  if not master  */

  
  LALFree( *searchParams );
  *searchParams = NULL;  

#ifdef FCT_SO_DEBUG
  
  printf("out of FinalizeSearch()\n");
#endif

  DETATCHSTATUSPTR (status);
  RETURN( status ); 
}


